﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Practices.EnterpriseLibrary.PolicyInjection.CallHandlers;
using Microsoft.Practices.Unity;

namespace Artech.UnityInMVP
{
    [ExceptionCallHandler("UI Exception Policy")]
    public class CalculatePresenter:MarshalByRefObject
    {
        public CalculatePresenter()
        {
            this.Calculator = new Calculator();
        }

        public ICalculateView View
        { get; set; }

        [Dependency]
        public ICalculator Calculator
        { get; set; }

        public void Calculate(int op1, int op2)
        {
            int result = this.Calculator.Divide(op1, op2);
            this.View.DisplayResult(result);
        }
    }
}
