﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Microsoft.Practices.Unity;
using Microsoft.Practices.Unity.Configuration;
using System.Configuration;
using Microsoft.Practices.EnterpriseLibrary.ExceptionHandling;

namespace Artech.UnityInMVP
{
    public partial class CalculateView : ViewBase, ICalculateView
    {
        public CalculateView()
        {
            InitializeComponent();                    
        }

        public CalculatePresenter Presenter
        { get; set; }

        #region ICalculateView Members

        public void DisplayResult(int result)
        {
            this.textBoxResult.Text = result.ToString();
        }

        #endregion

        private void buttonCalculate_Click(object sender, EventArgs e)
        {
            int op1;
            int op2;
            if(!int.TryParse(this.textBoxOp1.Text.Trim(), out op1))
            {
                return;
            }

             if(!int.TryParse(this.textBoxOp2.Text.Trim(), out op2))
            {
                return;
            }

             this.Presenter.Calculate(op1, op2);
        }

        private void CalculateView_Load(object sender, EventArgs e)
        {
            this.Presenter = this.UnityContainer.Resolve<CalculatePresenter>();
            this.Presenter.View = this;
        }
    }
}
