﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Practices.EnterpriseLibrary.ExceptionHandling;
using System.Windows.Forms;
using Microsoft.Practices.EnterpriseLibrary.ExceptionHandling.Configuration;
using Microsoft.Practices.EnterpriseLibrary.Common.Configuration.ObjectBuilder;
using Microsoft.Practices.EnterpriseLibrary.Common.Configuration;

namespace Artech.UnityInMVP.ExceptionHandlers
{
    [ConfigurationElementType(typeof(MessageBoxHandlerData))]
    class MessageBoxHandler:IExceptionHandler
    {
        #region IExceptionHandler Members

        public Exception HandleException(Exception exception, Guid handlingInstanceId)
        {
            MessageBox.Show(exception.Message, "Application Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
            return exception;
        }

        #endregion
    }

    [Assembler(typeof(MessageBoxHandlerAssembler))]
    class MessageBoxHandlerData : ExceptionHandlerData
    { }

    class MessageBoxHandlerAssembler : IAssembler<IExceptionHandler, ExceptionHandlerData>
    {
        #region IAssembler<IExceptionHandler,ExceptionHandlerData> Members

        public IExceptionHandler Assemble(Microsoft.Practices.ObjectBuilder2.IBuilderContext context, ExceptionHandlerData objectConfiguration, Microsoft.Practices.EnterpriseLibrary.Common.Configuration.IConfigurationSource configurationSource, ConfigurationReflectionCache reflectionCache)
        {
            return new MessageBoxHandler();
        }

        #endregion
    }

}
